source('graphfuncs.r')


n=2000
k=50

nseq = c(100,200,500,1000,5000,10000,20000,50000)
kseq = c(10,20,50,100,200)

bd <- function(x,u){xs = sqrt(rowMeans(x^2));x[xs <= u,,drop=F]}

#distu = function(x){sx=runif(2*x);sample(sx,x,prob=sx)}
distu = function(x,c=0.5){sx=runif(x); 0.5*(sqrt(c*c+4*sx+4*c*sx)-c)}
rt.dist = function(x){rt(x,1,0)}
dt.dist = function(x){dt(x,1,0)}
rmix = function(x){c(rnorm(floor(x/4),0,1),rnorm(floor(x*3/4),8,2))}
dmix = function(x){dnorm(x,0,1)/4+dnorm(x,8,2)*3/4}
rumix = function(x){ c(runif(floor(x/4),0,1),runif(floor(x*3/4),1,2))}
dumix = function(x){ c(dunif(x,0,1)/4+dunif(x,1,2)*3/4)}
generators=list(rnorm,rt.dist,rumix,rmix)
evaluators=list(dnorm,dt.dist,dumix,dmix)


k=kseq[3]
nrep = 5

set.seed(1)
alln=lapply(nseq,function(n){
  print(n)
  lapply(1:nrep,function(i){
    gen = generators[[1]]
    x = matrix(gen(n),ncol=1)
    k.graph = makeKNNG(matrix(x,ncol=1),k)
    st.distr = knnsampler(k.graph[[1]],k.graph[[2]],1L,10000000L)+1
    gdens=nv(st.distr^(1/3))
    knndens = nv(exp(knnDens(matrix(x,ncol=1),k,k.graph)))
    list(x=x,st.distr=st.distr,gdens=gdens,knndens=knndens,n=n,k=k)
  })
})

cormat=sapply(alln,function(j){
sapply(j,function(i){
  cor(i$gdens,i$knndens)
})
})

nrep=5
alln.logn=lapply(nseq,function(n){
  print(n)
  lapply(1:nrep,function(i){
    gen = generators[[1]]
    x = gen(n)
    k = floor(log(n)^2/4)
    k.graph = makeKNNG(matrix(x,ncol=1),k)
    k.igraph = graph.edgelist(do.call(rbind,lapply(1:nrow(k.graph[[1]]),function(i){cbind(i,k.graph[[1]][i,])})))
    s = 2*floor(sqrt(n)/log(n)^2)+1
    nbs=neighborhood(k.igraph,s,mode='out')
    st.distr = mknnsampler.list(nbs,floor(n^2/k^2),20)
    #st.distr = knnsampler(k.graph[[1]],k.graph[[2]],1L,floor(10000L * n))+1
    d=1
    piest = (st.distr * sapply(nbs,length)^(2/d))^(1/(1+2/d))
    gdens=nv(st.distr^(1/3))
    knndens = nv(exp(knnDens(matrix(x,ncol=1),k,k.graph)))
    list(x=x,st.distr=st.distr,gdens=gdens,knndens=knndens,n=n,k=k)
  })
})


n=20000

gen = generators[[3]]
x = gen(n)

x= distu(n,1)

k = 20#floor(log(n)^2/4)

#epsfun <- function(x,c){ c/evaluators[[3]](x)}
epsfun <- function(x,c,c2=1){ c / ((2*x+c2)/(1+c2)) }

nbs.init=sapply(1:length(x),function(i){
  d=abs(x-x[i])
  d[i]=Inf
  which(d<=epsfun(x[i],0.0006,1))
})
hist(sapply(nbs.init,length))
eps.igraph = graph.edgelist(do.call(rbind,lapply(1:length(x),function(i){cbind(i,nbs.init[[i]])})))
s=1
nbs=neighborhood(eps.igraph,s,mode='out')
clusters(eps.igraph)$csize

knn=floor(mean(sapply(nbs.init,length)))+1
k.graph = makeKNNG(matrix(x,ncol=1),knn)

k.igraph = graph.edgelist(do.call(rbind,lapply(1:nrow(k.graph[[1]]),function(i){cbind(i,k.graph[[1]][i,])})))
clusters(k.igraph,mode='strong')$csize

s = 1#floor(kt/k)+1#floor(sqrt(n)/log(n)^2)+1
nbs=neighborhood(k.igraph,s,mode='out')

st.distr = mknnsampler.list(nbs,500*floor(n^2/k^2),1)
                                        #st.distr = knnsampler(k.graph[[1]],k.graph[[2]],1L,floor(10000L * n))+1
d=1
piest = (st.distr * sapply(nbs,length)^(2/d))^(1/(1+2/d))
gdens=nv(st.distr^(1/3))
knndens = nv(exp(knnDens(matrix(x,ncol=1),k,k.graph)))

plot(x,knndens,pch=20,ylim=c(0,max(knndens)))
points(x,nv(piest),pch=20,col='red')
#points(x,nv(dest),pch=20,col='blue')
#points(x,nv(evaluators[[1]](x)),pch=20,col='blue')

plot(cumsum(knndens[order(x)]),type='l')
points(cumsum(nv(piest)[order(x)]),type='l',col='red')

cormat.logn=sapply(alln.logn,function(j){
sapply(j,function(i){
  sel = i$gdens>0
  sum((log(i$gdens)-log(i$knndens))[sel]*i$gdens[sel])
  cor(i$gdens,i$knndens)
})
})
boxplot(cormat.logn)
#plot(colMeans(cormat.logn),type='o')

alln.sqrt=lapply(nseq,function(n){
  print(n)
  lapply(1:nrep,function(i){
    gen = generators[[1]]
    x = gen(n)
    k = floor(sqrt(n)/3)
    #k = floor(n^(1/4))
    k.graph = makeKNNG(matrix(x,ncol=1),k)
    st.distr = knnsampler(k.graph[[1]],k.graph[[2]],1L,floor(10000L * n))+1
    gdens=nv(st.distr^(1/3))
    knndens = nv(exp(knnDens(matrix(x,ncol=1),k,k.graph)))
    list(x=x,st.distr=st.distr,gdens=gdens,knndens=knndens,n=n,k=k)
  })
})

cormat.sqrt=sapply(alln.sqrt,function(j){
sapply(j,function(i){
  cor(i$gdens,i$knndens)
})
})
boxplot(cormat.sqrt)


alam.sqrt=lapply(nseq,function(n){
  print(n)
  lapply(1:nrep,function(i){
    gen = generators[[1]]
    x = matrix(gen(n),ncol=1)
    k = floor(sqrt(n)*5)
    k.graph = makeKNNG(matrix(x,ncol=1),k)
    gdens=nv(exp(alamEst(x,k,k.graph)))
    knndens = nv(exp(knnDens(matrix(x,ncol=1),k,k.graph)))
    list(x=x,gdens=gdens,knndens=knndens,n=n,k=k)
  })
})

cormat.alam.sqrt=sapply(alam.sqrt,function(j){
sapply(j,function(i){
  cor(i$gdens,i$knndens)
})
})
boxplot(cormat.alam.sqrt)

alam.log=lapply(nseq,function(n){
  print(n)
  lapply(1:nrep,function(i){
    gen = generators[[1]]
    x = matrix(gen(n),ncol=1)
    k = floor(log(n)*10)
    k.graph = makeKNNG(matrix(x,ncol=1),k)
    gdens=nv(exp(alamEst(x,k,k.graph)))
    knndens = nv(exp(knnDens(matrix(x,ncol=1),k,k.graph)))
    list(x=x,gdens=gdens,knndens=knndens,n=n,k=k)
  })
})

cormat.alam.log=sapply(alam.log,function(j){
sapply(j,function(i){
  cor(i$gdens,i$knndens)
})
})
boxplot(cormat.alam.log)



df.byn=data.frame(x=log(nseq,10),const=apply(cormat,2,mean),logn=apply(cormat.logn,2,mean),sqrt=apply(cormat.sqrt,2,mean),alam.sqrt=apply(cormat.alam.sqrt,2,mean),alam.log=apply(cormat.alam.log,2,mean))
sd.byn=data.frame(x=log(nseq,10),const=apply(cormat,2,sd),logn=apply(cormat.logn,2,sd),sqrt=apply(cormat.sqrt,2,sd),alam.sqrt=apply(cormat.alam.sqrt,2,sd),alam.log=apply(cormat.alam.log,2,sd))

pdf('scalen.pdf')
require('gplots')
plotCI(df.byn[,1],df.byn[,2],uiw=sd.byn[,2],ylim=c(0.5,1),type='o',xlab='log_10 number of points',ylab='correlation of metric vs graph density')
plotCI(df.byn[,1],df.byn[,3],uiw=sd.byn[,3],col='red',type='o',add=T)
plotCI(df.byn[,1],df.byn[,4],uiw=sd.byn[,4],col='blue',type='o',add=T)
plotCI(df.byn[,1],df.byn[,5],uiw=sd.byn[,5]/2,col='green',type='o',add=T)
plotCI(df.byn[,1],df.byn[,6],uiw=sd.byn[,6]/2,col='maroon',type='o',add=T)
legend('bottomleft',legend=c('random walk, k=const','random walk, k=log(n)','random walk, k=sqrt(n)','path integral, k=log(n)','path integral, k=sqrt(n)'),col=c('black','red','blue','maroon','green'),lwd=1,bg='white')
dev.off()

n=5000
j=1
bound=1

distl = c(1,5,10,20,40)

set.seed(1)
alld.sqrt.normal=
  lapply(c(200,500,5000),function(n){
  sapply(distl,function(d){
    print(d)
    cs=sapply(1:nrep,function(i){
      gen = generators[[j]]
      x = bd(matrix(do.call(c,lapply(1:d,function(i){gen(n)})),ncol=d),bound)
      n=nrow(x)
      print(nrow(x))
      dx = evaluators[[j]](x)
      truedens=rowSums(log(dx))
      k = floor(sqrt(n))*5
      k.graph = makeKNNG(matrix(x,ncol=d),k)
      st.distr=knnsampler(k.graph[[1]],k.graph[[2]],1L,floor(10^6))+1
      gdens=nv(st.distr^(1/(2/d+1)))
      knndens = knnDens(matrix(x,ncol=d),k,k.graph)
      knndens = nv(exp(knndens-mean(knndens)))
      #list(x=x,st.distr=st.distr,gdens=gdens,knndens=knndens,n=n,k=k,bound=bound,genid=j,truedens=truedens,d=d)
      cor(gdens,knndens)
    })
    c(d,mean(cs),quantile(cs,c(0.25,0.5,0.75)),sd(cs))
  })
})

n=500
set.seed(1)
alld.log.normal=
  sapply(distl,function(d){
    print(d)
    cs=sapply(1:nrep,function(i){
      gen = generators[[j]]
      x = bd(matrix(do.call(c,lapply(1:d,function(i){gen(n)})),ncol=d),bound)
      n=nrow(x)
      print(nrow(x))
      dx = evaluators[[j]](x)
      truedens=rowSums(log(dx))
      k = floor(sqrt(n))*5
      k.graph = makeKNNG(matrix(x,ncol=d),k)
      st.distr=knnsampler(k.graph[[1]],k.graph[[2]],1L,floor(10^6))+1
      gdens=nv(st.distr^(1/(2/d+1)))
      knndens = knnDens(matrix(x,ncol=d),k,k.graph)
      knndens = nv(exp(knndens-mean(knndens)))
      lf=lm(log(knndens)~log(gdens))
      #list(x=x,st.distr=st.distr,gdens=gdens,knndens=knndens,n=n,k=k,bound=bound,genid=j,truedens=truedens,d=d)
      cor(log(gdens),log(knndens))
    })
    c(d,mean(cs),quantile(cs,c(0.25,0.5,0.75)),sd(cs))
  })

require(gplots)
pdf('dimension.pdf',5,5)
plotCI(alld.log.normal[1,],alld.log.normal[2,],ui=alld.log.normal[5,],li=alld.log.normal[3,],ylim=c(0.5,1),log='x',lwd=2,xlab='dimensions',ylab='correlation')
plotCI(alld.sqrt.normal[[1]][1,],alld.sqrt.normal[[1]][2,],ui=alld.sqrt.normal[[1]][5,],li=alld.sqrt.normal[[1]][3,],log='x',col='red',add=T,lwd=2)
#plotCI(alld.sqrt.normal[[2]][1,],alld.sqrt.normal[[2]][2,],ui=alld.sqrt.normal[[2]][5,],li=alld.sqrt.normal[[2]][3,],log='x',col='blue',add=T,lwd=2)
plotCI(alld.sqrt.normal[[3]][1,],alld.sqrt.normal[[3]][2,],ui=alld.sqrt.normal[[3]][5,],li=alld.sqrt.normal[[3]][3,],log='x',col='blue',add=T,lwd=2)
legend('bottomleft',col=c('black','blue','red'),legend=c('log(p), n=500','p, n=200','p, n=10000'),lwd=2)
dev.off()

#####
# compare vs alamgir

n= 2000
k= 100
d=1

pdf('examples.pdf',10,10)
set.seed(1)
par(mfrow=c(2,2))
for(j in 1:4){
  x = bd(matrix(generators[[j]](n),ncol=1),15)
  k.graph = makeKNNG(matrix(x,ncol=d),k)
  st.distr = mknnsampler(k.graph,10000000L,10)
  st.ref=st.distr
  gdens=nv(st.ref^(1/3))
  knndens = nv(exp(knnDens(matrix(x,ncol=d),k,k.graph)))
#
  denest=alamEst(x,k,k.graph)
  sx = sort(x[,1])
  ox = order(x[,1])
plot(sx,exp(denest-mean(denest))[ox],ylim=c(0,3),type='l',col='green',lwd=2,xlab='x',ylab='density')
  rug(sx)
points(sx,exp(log(st.distr)/3-mean(log(st.distr)/3))[ox],col='red',type='l',lwd=2)
points(sx,exp(log(knndens)-mean(log(knndens)))[ox],col='blue',type='l',lwd=2)
points(sx,exp(log(evaluators[[j]](x[,1]))-mean(log(evaluators[[j]](x[,1]))))[ox],col='black',type='l',lwd=2)
  if(j==2){
    legend('topright',col=c('black','red','blue','green'),legend=c('ground truth','graph random walk','metric k-nn estimator','path integral'),lwd=2)
  }
}
dev.off()


uspsrl=t(sapply(strsplit(readLines('dat/usps_train.jf')[-1],' '),as.double))
uspsdat = uspsrl[1:2000,-1]
uspstrue = uspsrl[1:2000,1]

k=100
k.graph = makeKNNG(uspsdat,k)
k.igraph = graph.edgelist(do.call(rbind,lapply(1:nrow(k.graph[[1]]),function(i){cbind(i,k.graph[[1]][i,])})))
cl=clusters(k.igraph,mode='strong')
nbs=neighborhood(k.igraph,1,mode='out')
st.distr = mknnsampler(k.graph,1000000L,1000)

d=5
gdens=nv(st.distr^(1/(1+2/d)))
epsest = (1/(st.distr))^(1/(2+d))

pce=get.edgelist(k.igraph)
E(k.igraph)$weight = epsest[pce[,1]]
sps.wt=shortest.paths(k.igraph)

sps = shortest.paths(k.igraph,weights=NA)
unwt=cmdscale(sps)



####
# weight distances
nbint=t(sapply(nbs,function(i){
  sapply(i,function(j){
    c(sum(i%in%nbs[[j]]))
  })
}))

d=5
n=10000000
xin=sapply(1:d,function(i){runif(n)})
inbd = sqrt(rowSums(xin^2)) <= 1
xin = xin[which(inbd)[1:min(sum(inbd),1000000)],]

xr=rowSums(xin[,-1]^2)
dseq = seq(0,2,length=1000)
sp2=sapply(dseq,function(i){
  sum(sqrt((xin[,1]-i)^2 + xr) < 1)/nrow(xin)
})
estds.uncr=approx(sp2,dseq,nbint[j,]/(k+1),rule=0,ties=min)$y
gel=get.edgelist(k.igraph)
gol=apply(gel,1,function(i){
  sum(nbs[[i[1]]]%in%nbs[[i[2]]]/(k+1))
})
epsout=approx(sp2,dseq,gol,rule=0,ties=min)$y * epsest[gel[,1]]

E(k.igraph)$weight = epsout

cl=clusters(k.igraph,mode='strong')
cl.assign = cl$membership == which.max(cl$csize)
sps.wt=shortest.paths(subgraph(k.igraph,which(cl.assign)))

wt = cmdscale(sps.wt,k=2)

sj=similarity.jaccard(k.igraph,mode='out')

set.seed(1)
samp=sample(1:nrow(uspsdat),10)


pdf('examples.usps.pdf',20,10)
for(i in 1:length(samp)){
  par(mfrow=c(2,5))
  dt = colSums((t(uspsdat)-uspsdat[samp[i],])^2)
  subset = (1:length(nbs))[-nbs[[samp[i]]]]
  o1=c(samp[i],subset[order(-sj[samp[i],subset])[1:5]])
  o2=c(samp[i],subset[order(sps.wt[samp[i],subset])[1:5]])
  for(j in 1:5){
    image(matrix(uspsdat[o1[j],],nrow=16)[,16:1])
  }
  for(j in 1:5){
    image(matrix(uspsdat[o2[j],],nrow=16)[,16:1])
  }
}
dev.off()


dusps = as.matrix(dist(uspsdat))

pdf('usps.pdf')
par(mfrow=c(2,2))
plot(wt,col=rainbow(10)[uspstrue+1],pch=format(uspstrue),cex=0.5,xlab='PC1',ylab='PC2')
plot(unwt,col=rainbow(10)[uspstrue+1],pch=format(uspstrue),cex=0.5,xlab='PC1',ylab='PC2')
plot(prcomp(uspsdat)$x,col=rainbow(10)[uspstrue+1],pch=format(uspstrue),cex=0.5,xlab='PC1',ylab='PC2')
plot(dusps[1:50,],sps.wt[1:50,],pch='.',cex=2,xlab='true distance',ylab='predicted distance')
points(dusps[1:50,],sps[1:50,]/2,pch='.',col='red',cex=2)
legend('topleft',legend=c('estimated distance','unweighted distance'),col=c('black','red'),pch=20)
dev.off()


#######
### Kernel stuff
#
set.seed(1)
n=5000
j=4
gen = generators[[j]]
x = matrix(gen(n),ncol=1)
dist.x = as.matrix(dist(x))

kern <- function(x,bw){
  prs = exp(-x * bw)
  tr = runif(length(x)) <= prs & x != 0
}

idk <- function(d,x){sort(d)[100]}
idcons <- function(d,x){1}
idlin <- function(d,x){abs(x)/10+0.1}

idlist <- list(idk,idcons,idlin)
l = 3

pdf('kernel.pdf',10,10)
par(mfrow=c(2,2))
for(l in 1:3){
nbs=sapply(1:nrow(dist.x),function(i){
  id=idlist[[l]](dist.x[i,],x[i,])
  as.integer(which(kern(dist.x[i,],2/id)))
})
st.distr = mknnsampler.list(nbs,1000000L,10)
d=1
piest = (st.distr * sapply(nbs,length)^(2/d))^(1/(1+2/d))
piest.sd = (st.distr)^(1/(1+2/d))
piest.knn = sapply(nbs,length)
#piest = (st.distr)^(1/(1+2/d))
sx = sort(x[,1])
rx = order(x[,1])
plot(sx,nv(piest)[rx],type='l',lwd=2,xlab='x',ylab='density')
points(sx,nv(piest.knn)[rx],col='green',type='l',lwd=2)
points(sx,nv(piest.sd)[rx],col='maroon',type='l',lwd=2)
points(sx,nv(evaluators[[j]](x[,1]))[rx],col='red',type='l',lwd=2)
if(l==2){
  legend('topleft',col=c('black','red','green','maroon'),lwd=2,legend=c('estimator','ground truth','degree only','stationary distr only'))
}
}
dev.off()



####
# amazon data
# available from: http://snap.stanford.edu/data/amazon-meta.html

rl.amazon=readLines('amazon/amazon-meta.txt')
id.amazon = grep('Id:',rl.amazon)
asin.amazon = grep('ASIN:',rl.amazon)
sim.amazon = grep('similar:',rl.amazon)
srank.amazon = grep('salesrank:',rl.amazon)

sim.id=id.amazon[findInterval(sim.amazon,id.amazon)]
asin.id=asin.amazon[findInterval(sim.amazon,asin.amazon)]
srank.id=srank.amazon[findInterval(sim.amazon,srank.amazon)]

asin.split = do.call(rbind,strsplit(rl.amazon[asin.id],' '))[,2]
nbs=strsplit(rl.amazon[sim.amazon],' ')
length(which(sapply(nbs,length)>4))

edgelist=do.call(rbind,lapply(which(sapply(nbs,length)>4),function(i){
  cbind(asin.split[i],nbs[[i]][seq(6,length(nbs[[i]]),by=2)])
}))
  
gel=graph.edgelist(edgelist)
cls=clusters(gel,mode='strong')
cls$csize[which.max(cls$csize)]

subsel = which(cls$membership == which.max(cls$csize))
amz.graph = subgraph(gel,subsel)

nbs = neighborhood(amz.graph,1,mode='out')
nbs = lapply(nbs,function(i){i[-1]})
ksamps=mknnsampler.list(nbs,2000000L,100)

d=10
epsest = (degree(amz.graph,mode='in')/(ksamps))^(1/(2+d))
piest = (ksamps * degree(amz.graph,mode='in')^(2/d))^(1/(1+2/d))

E(amz.graph)$weight=epsest[get.edgelist(amz.graph)[,1]]
sps.wt = shortest.paths(amz.graph)
sps=shortest.paths(amz.graph,weights=NA)

toName<-function(nodes){
  tmp.id = V(amz.graph)$name[nodes]
  rl.amazon[asin.id[match(tmp.id,asin.split)]+1]
}
toSrank<-function(nodes){
  tmp.id = V(amz.graph)$name[nodes]
  sapply(strsplit(rl.amazon[srank.id[match(tmp.id,asin.split)]],' '),function(i){i[4]})
}
toSubj<-function(nodes){
  tmp.id = V(amz.graph)$name[nodes]
  sapply(strsplit(rl.amazon[srank.id[match(tmp.id,asin.split)]+3],'|',fixed=T),function(i){if(length(i)>=4){i[2:4]}else{rep('',3)}})
}

###
# modes

nb2 = neighborhood(amz.graph,2,mode='out')
mpel=t(sapply(1:length(nb2),function(i){
  cd=c(i,nb2[[i]])
  c(i,cd[which.max(piest[cd])])
}))
gascent=graph.edgelist(mpel)
cascent=clusters(gascent)
csizes = order(-cascent$csize)
clusids=sapply(csizes,function(i){
  members=which(i==cascent$membership)
  members[order(-piest[members])[1:10]]
})

titles=sapply(1:5,function(i){
  tn=toName(clusids[,i])
  nc = nchar(tn)
  nc[nc>40]=40
  substr(tn,10,nc)[1:5]
})
colnames(titles)=c('Classics','Literature','Classical music','Philosophy','Religion')

require(xtable)
xt=xtable(titles)
print(xtable(titles),file='xt.txt')

###
# centrality
bw = betweenness(amz.graph,weights=NA)
cl = closeness(amz.graph,weights=NA)
ev = evcent(amz.graph,weights=NA)

sr=as.double(toSrank(1:vcount(amz.graph)))

ldat = list(piest,bw,cl,ev$vector)

resl = 200
iqr = function(x){ diff(quantile(x,c(0.25,0.75)))}
msd=sapply(floor(length(sr)/(2*resl)):floor(length(sr)/resl),function(i){
  y=lapply(ldat,function(j){
    x=sr[which(floor(rank(j,ties.method='first')/resl)==i)]
    c(mean(x),iqr(x))
  })
  do.call(c,y)
})

require(gplots)
pdf('salesrank.pdf',7,4)
plotCI(seq(0.5,1,length=ncol(msd)),msd[1,],uiw = msd[2,]/4,type='l',log='y',ylab='sales rank',xlab='quantile centrality',ylim=c(300000,40000)cex.lab=1.5, cex.axis=1.5)
plotCI(seq(0.5,1,length=ncol(msd)),msd[3,],uiw = msd[4,]/4,type='l',add=T,col=rgb(1,0,0,alpha=0.5))
plotCI(seq(0.5,1,length=ncol(msd)),msd[7,],uiw = msd[8,]/4,type='l',add=T,col=rgb(0,0,1,alpha=0.5))
legend('topleft',col=c('black','red','blue'),legend=c('random walk','betweenness','closeness'),lwd=2)
dev.off()

cor(sr,piest,method='spearman')
cor(sr,bw,method='spearman')
cor(sr,cl,method='spearman')

modes=which(ksamps>10)

smode = toSubj(modes)[3,]
ssel = smode%in%names(which(table(smode) > 200))
smode.sub=smode[ssel]
len.sm = length(unique(smode.sub))
require(MASS)
modesel = modes[ssel]
inity=cmdscale(sps.wt[modesel,modesel],2)
reord = as.vector(matrix(1:length(unique(smode.sub)),2,byrow=T))

require(RColorBrewer)
cols = brewer.pal(len.sm,'Dark2')
pdf('amzembed.pdf',5.5,5)
plot(inity,pch=format(match(smode.sub,unique(smode.sub))),col=cols[reord][match(smode.sub,unique(smode.sub))],cex=0.7,xlab='PC1',ylab='PC2')
legend('topright',pch=format(1:length(unique(smode.sub))),col=cols[reord],legend=unique(smode.sub),cex=0.7)
dev.off()


